<?php
/******************************************************************************
 *
 *	 COMPANY: Intelliants LLC
 *	 PROJECT: Subrion Content Management System
 *	 VERSION: 3.1.2
 *	 LICENSE: http://www.subrion.com/license.html
 *	 http://www.subrion.com/
 *
 *	 This program is an open source php content management system.
 *
 *	 Link to Subrion.com may not be removed from the software pages
 *	 without permission of Subrion CMS respective owners. Copyright
 *	 link may be removed for the paid versions only.
 *
 *	 PHP code copyright notice may not be removed from source code
 *	 in any case.
 *
 *	 Copyright 2009-2013 Intelliants LLC
 *	 http://www.intelliants.com/
 *
 ******************************************************************************/


if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	$packageName = explode('_stats', $iaView->name());
	$packageName = array_shift($packageName);

	$iaCore->startHook('phpAdminPackageStatistics', array('package' => $packageName));

	$statistics = array();

	$iaItem = $iaCore->factory('item');
	if ($packageItems = $iaItem->getItemsByPackage($packageName))
	{
		foreach ($packageItems as $itemName)
		{
			$itemName = substr($itemName, 0, -1);
			$itemClass = $iaCore->factoryPackage($itemName, $packageName, iaCore::ADMIN);
			if (method_exists($itemClass, 'getDashboardStatistics'))
			{
				if ($itemClass->dashboardStatistics)
				{
					if ($data = $itemClass->getDashboardStatistics(false))
					{
						$statistics[$itemName] = $data;
					}
				}
			}
		}
	}

	$timeline = $iaCore->factory('log')->get($packageName);

	$iaView->assign('package', $packageName);
	$iaView->assign('statistics', $statistics);
	$iaView->assign('timeline', $timeline);

	$iaView->display('statistics');
}