<?php
/******************************************************************************
 *
 *	 COMPANY: Intelliants LLC
 *	 PROJECT: Subrion Content Management System
 *	 VERSION: 3.1.2
 *	 LICENSE: http://www.subrion.com/license.html
 *	 http://www.subrion.com/
 *
 *	 This program is an open source php content management system.
 *
 *	 Link to Subrion.com may not be removed from the software pages
 *	 without permission of Subrion CMS respective owners. Copyright
 *	 link may be removed for the paid versions only.
 *
 *	 PHP code copyright notice may not be removed from source code
 *	 in any case.
 *
 *	 Copyright 2009-2013 Intelliants LLC
 *	 http://www.intelliants.com/
 *
 ******************************************************************************/


if (iaView::REQUEST_JSON == $iaView->getRequestType())
{
	if (isset($_POST['action']))
	{
		$output = array('error' => true, 'message' => array());

		$iaUsers = $iaCore->factory('users');

		switch ($_POST['action'])
		{
			case 'edit_picture_title':

				$title = isset($_POST['value']) ? iaSanitize::sql($_POST['value']) : '';
				$item = isset($_POST['item']) ? iaSanitize::sql($_POST['item']) : false;
				$field = isset($_POST['field']) ? iaSanitize::sql($_POST['field']) : false;
				$path = isset($_POST['path']) ? iaSanitize::sql($_POST['path']) : false;
				$itemId = isset($_POST['itemid']) ? (int)$_POST['itemid'] : false;

				if ($itemId && $item && $field && $path)
				{
					$tableName = $iaCore->factory('item')->getItemTable($item);

					if (iaUsers::getItemName() == $item)
					{
						$itemValue = $iaDb->one($field, iaDb::convertIds($itemId), $tableName);
						$memberId = $itemId;
					}
					else
					{
						$row = $iaDb->row($field . ', `member_id` `id`', iaDb::convertIds($itemId), $tableName);
						$itemValue = $row[$field];
						$memberId = $row['id'];
					}

					if (iaUsers::hasIdentity() && $memberId == iaUsers::getIdentity()->id && $itemValue)
					{
						$pictures = null;
						if ($itemValue[1] == ':')
						{
							$array = unserialize($itemValue);
							if (is_array($array) && $array)
							{
								$pictures = $array;
							}
						}
						else
						{
							if ($array = explode(',', $itemValue))
							{
								$pictures = $array;
							}
						}

						if (is_array($pictures))
						{
							foreach ($pictures as $i => $value)
							{
								if (is_array($value))
								{
									if ($path == $value['path'])
									{
										$pictures[$i]['title'] = $title;
									}
								}
								else
								{
									if ($path == $value)
									{
										$key = $i;
									}
								}
							}

							$newValue = is_array($value) ? serialize($pictures) : implode(',', $pictures);
							$iaDb->update(array($field => $newValue), iaDb::convertIds($itemId), null, $tableName);

							if (iaUsers::getItemName() == $item)
							{
								// update current profile data
								if ($itemId == iaUsers::getIdentity()->id)
								{
									$iaUsers->getAuth($itemId);
								}
							}
						}
					}
				}
				break;

			case 'delete-file':

				$item = isset($_POST['item']) ? iaSanitize::sql($_POST['item']) : false;
				$field = isset($_POST['field']) ? iaSanitize::sql($_POST['field']) : false;
				$path = isset($_POST['path']) ? iaSanitize::sql($_POST['path']) : false;
				$itemId = isset($_POST['itemid']) ? (int)$_POST['itemid'] : false;

				if ($itemId && $item && $field && $path)
				{
					$tableName = $iaCore->factory('item')->getItemTable($item);

					if (iaUsers::getItemName() == $item)
					{
						$itemValue = $iaDb->one($field, iaDb::convertIds($itemId), $tableName);
						$memberId = $itemId;
					}
					else
					{
						$row = $iaDb->row($field . ', `member_id` `id`', iaDb::convertIds($itemId), $tableName);
						$itemValue = $row[$field];
						$memberId = $row['id'];
					}

					if (iaUsers::hasIdentity() && $memberId == iaUsers::getIdentity()->id && $itemValue)
					{
						$pictures = null;
						if ($itemValue[1] == ':')
						{
							$array = unserialize($itemValue);
							if (is_array($array) && $array)
							{
								$pictures = $array;
							}
						}
						else
						{
							if ($array = explode(',', $itemValue))
							{
								$pictures = $array;
							}
						}

						$key = false;
						if (is_array($pictures))
						{
							foreach ($pictures as $i => $value)
							{
								if (is_array($value))
								{
									if ($path == $value['path'])
									{
										$key = $i;
										break;
									}
								}
								else
								{
									if ($path == $value)
									{
										$key = $i;
										break;
									}
								}
							}
							if (false !== $key)
							{
								unset($pictures[$key]);
							}
							$newValue = is_array($value) ? serialize($pictures) : implode(',', $pictures);
						}
						else
						{
							// single image
							$newValue = '';
							if ($pictures == $path)
							{
								$key = true;
							}
						}

						if ($key !== false)
						{
							$iaDb->update(array($field => $newValue), iaDb::convertIds($itemId), null, $tableName);

							$iaPicture = $iaCore->factory('picture');
							$iaPicture->delete($path);

							$output = array('error' => false, 'message' => iaLanguage::get('deleted'));

							if (iaUsers::getItemName() == $item)
							{
								// update current profile data
								if ($itemId == iaUsers::getIdentity()->id)
								{
									$iaUsers->getAuth($itemId);
								}
							}
						}
					}
				}

				break;

			case 'send_email':

				$memberInfo = $iaUsers->getInfo((int)$_POST['author_id']);

				if (empty($memberInfo) || $memberInfo['status'] != iaCore::STATUS_ACTIVE)
				{
					$output['message'][] = iaLanguage::get('member_doesnt_exist');
				}

				if (empty($_POST['from_name']))
				{
					$output['message'][] = iaLanguage::get('incorrect_fullname');
				}

				if (empty($_POST['from_email']) || !iaValidate::isEmail($_POST['from_email']))
				{
					$output['message'][] = iaLanguage::get('error_email_incorrect');
				}

				if (empty($_POST['email_body']))
				{
					$output['message'][] = iaLanguage::get('err_message');
				}

				if ($captchaName = $iaCore->get('captcha_name'))
				{
					$iaCaptcha = $iaCore->factoryPlugin($captchaName, iaCore::FRONT, 'captcha');
					if (!$iaCaptcha->validate())
					{
						$output['message'][] = iaLanguage::get('confirmation_code_incorrect');
					}
				}

				if (empty($output['message']))
				{
					$iaMailer = $iaCore->factory('mailer');

					$subject = iaLanguage::getf('author_contact_request', array('title' => $_POST['regarding']));

					$iaMailer->FromName  = $_POST['from_name'];
					$iaMailer->From = $_POST['from_email'];
					$iaMailer->AddAddress($memberInfo['email']);
					$iaMailer->Subject = $subject;
					$iaMailer->Body = strip_tags($_POST['email_body']);

					$output['error'] = !$iaMailer->Send();
					$output['message'][] = iaLanguage::get($output['error'] ? 'unable_to_send_email' : 'mail_sent');
				}
		}
	}

	$iaView->assign($output);
}

if (isset($_GET) && isset($_GET['action']))
{
	switch ($_GET['action'])
	{
		case 'ckeditor_upload':

			$iaView->disableLayout();
			$iaView->set('nodebug', 1);

			$err = 0;

			if (isset($_GET['Type']) && 'Image' == $_GET['Type'] && isset($_FILES['upload']))
			{
				$oFile = $_FILES['upload'];
				$sErrorNumber = '0';

				$imgTypes = array(
					'image/gif' => 'gif',
					'image/jpeg' => 'jpg',
					'image/pjpeg' => 'jpg',
					'image/png' => 'png'
				);
				$_user = iaUsers::hasIdentity() ? iaUsers::getIdentity()->username : false;
				$sFileUrl = 'uploads/' . iaUtil::getAccountDir($_user);

				$ext = array_key_exists($oFile['type'], $imgTypes) ? $imgTypes[$oFile['type']] : false;

				if (!$ext)
				{
					$err = '202 error';
				}

				$tok = iaUtil::generateToken();
				$fname = $tok . '.' . $ext;

				if (!$err)
				{
					move_uploaded_file($oFile['tmp_name'], IA_HOME . $sFileUrl . $fname);
					chmod(IA_HOME . $sFileUrl . $fname, 0777);
				}

				// fix windows URLs
				$fileUrl = $sFileUrl . $fname;
				$fileUrl = str_replace('\\', '/', $fileUrl);

				$callback = (int)$_GET['CKEditorFuncNum'];

				$output = '<html><body><script type="text/javascript">';
				$output .= "window.parent.CKEDITOR.tools.callFunction('$callback', '" . IA_CLEAR_URL . $fileUrl . "', '');";
				$output .= '</script></body></html>';

				die($output);
			}
	}
}