<?php
/******************************************************************************
 *
 *	 COMPANY: Intelliants LLC
 *	 PROJECT: Subrion Content Management System
 *	 VERSION: 3.1.2
 *	 LICENSE: http://www.subrion.com/license.html
 *	 http://www.subrion.com/
 *
 *	 This program is an open source php content management system.
 *
 *	 Link to Subrion.com may not be removed from the software pages
 *	 without permission of Subrion CMS respective owners. Copyright
 *	 link may be removed for the paid versions only.
 *
 *	 PHP code copyright notice may not be removed from source code
 *	 in any case.
 *
 *	 Copyright 2009-2013 Intelliants LLC
 *	 http://www.intelliants.com/
 *
 ******************************************************************************/


$iaItem = $iaCore->factory('item');
$iaUsers = $iaCore->factory('users');

if (iaView::REQUEST_JSON == $iaView->getRequestType())
{
	if (isset($_GET['item']))
	{
		$allItems = array_keys($iaItem->getItems());
		$itemName = in_array($_GET['item'], $allItems) ? $_GET['item'] : $iaUsers->getItemName();
		$itemId = (int)$_GET['item_id'];

		if (iaUsers::getIdentity()->id && $itemId)
		{
			switch ($_GET['action'])
			{
				case iaCore::ACTION_ADD:
					$iaDb->query(iaDb::printf("INSERT IGNORE `:prefix:table` (`id`, `member_id`, `item`) VALUES (:id, :user, ':item')", array(
						'prefix' => $iaDb->prefix,
						'table' => $iaItem->getFavoritesTable(),
						'id' => $itemId,
						'user' => iaUsers::getIdentity()->id,
						'item' => $itemName
					)));

					break;

				case iaCore::ACTION_DELETE:
					$iaDb->delete('`id` = :item_id AND `member_id` = :user AND `item` = :item',
						$iaItem->getFavoritesTable(),
						array(
							'item_id' => $itemId,
							'user' => iaUsers::getIdentity()->id,
							'item' => $itemName
						)
					);
			}

			$result = (bool)$iaDb->getAffected();

			$iaView->assign('error', !$result);
		}
	}
}

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	if (!iaUsers::hasIdentity())
	{
		iaView::errorPage(iaView::ERROR_UNAUTHORIZED);
	}

	$favorites = $iaItem->getFavoritesByMemberId(iaUsers::getIdentity()->id);

	if ($favorites)
	{
		$itemInfo = array();
		$itemsList = $iaItem->getPackageItems();

		// TODO: implement pagination

		$iaField = $iaCore->factory('field');

		foreach ($favorites as $itemName => $ids)
		{
			$itemIds = array();
			foreach ($ids as $id)
			{
				$itemIds[] = $id['id'];
			}
			$ids = implode(', ', $itemIds);

			$fields = array('id');

			$favorites[$itemName]['fields'] = $iaField->filter($itemInfo, $itemName);

			$class = ('core' != $itemsList[$itemName])
				? $iaCore->factoryPackage('item', $itemsList[$itemName], iaCore::FRONT, $itemName)
				: $iaCore->factory('members' == $itemName ? 'users' : $itemName);

			if ($class && method_exists($class, iaUsers::TAB_FILLER_FAVORITES_METHOD))
			{
				$favorites[$itemName]['items'] = $class->{iaUsers::TAB_FILLER_FAVORITES_METHOD}($ids, $fields);
			}
			else
			{
				if ($itemName == $iaUsers->getItemName())
				{
					$fields[] = 'username';
					$fields[] = 'id` `member_id';
				}
				else
				{
					$fields[] = 'member_id';
				}

				foreach ($favorites[$itemName]['fields'] as $f)
				{
					$fields[] = $f['name'];
				}

				$stmt = iaDb::printf("`id` IN (:ids) AND `status` = ':active'", array('ids' => $ids, 'active' => iaCore::STATUS_ACTIVE));

				$favorites[$itemName]['items'] = $iaDb->all('`' . implode('`,`', $fields) . '`, 1 `favorite`', $stmt, null, null, $iaItem->getItemTable($itemName));
			}

			$iaCore->startHook('phpFavoritesAfterGetExtraItems', array('favorites' => &$favorites, 'item' => $itemName));
		}
	}

	$iaView->assign('favorites', $favorites);
}